oeffnungszeitenbuch.jQuery(document).ready(function($) {
	
    refreshWidget();
    
    $('.preview_update').change(function() {
		refreshWidget();
	});
	
	$('.color_picker').ColorPicker({ 
        onChange: function(hsb, hex, rgb, el) {
        	$('#'+el.id).val('#'+hex);
        	$('#'+el.id).css('background', '#'+hex);
        	$('#'+el.id).css('color', getContrastYIQ(hex)=='black' ? '#000000' : '#FFFFFF');
            refreshWidget();
        },
        onBeforeShow: function () {
            $(this).ColorPickerSetColor($(this).val());
        },
        onSubmit: function(hsb, hex, rgb, el) {
        	$('#'+el.id).val('#'+hex);
        	$('#'+el.id).css('background', '#'+hex);
        	$('#'+el.id).css('color', getContrastYIQ(hex)=='black' ? '#000000' : '#FFFFFF');
            refreshWidget();
        },
        onHide: function(el) {
            refreshWidget();
        }
    });
    
    function getContrastYIQ(hexcolor){
    	hexcolor = hexcolor.replace('#', '');
        var r = parseInt(hexcolor.substr(0,2),16);
        var g = parseInt(hexcolor.substr(2,2),16);
        var b = parseInt(hexcolor.substr(4,2),16);
        var yiq = ((r*299)+(g*587)+(b*114))/1000;
        return (yiq >= 128) ? 'black' : 'white';
    }
	    
    function refreshWidget() {
    	$('#jform_params_color_widget_bg').css('background', $('#jform_params_color_widget_bg').val());
    	$('#jform_params_color_widget_bg').css('color', getContrastYIQ($('#jform_params_color_widget_bg').val())=='black' ? '#000000' : '#FFFFFF');
    	$('#jform_params_color_text').css('background', $('#jform_params_color_text').val());
    	$('#jform_params_color_text').css('color', getContrastYIQ($('#jform_params_color_text').val())=='black' ? '#000000' : '#FFFFFF');
    	$('#jform_params_color_headline_bg').css('background', $('#jform_params_color_headline_bg').val());
    	$('#jform_params_color_headline_bg').css('color', getContrastYIQ($('#jform_params_color_headline_bg').val())=='black' ? '#000000' : '#FFFFFF');
    	$('#jform_params_color_headline').css('background', $('#jform_params_color_headline').val());
    	$('#jform_params_color_headline').css('color', getContrastYIQ($('#jform_params_color_headline').val())=='black' ? '#000000' : '#FFFFFF');
    	$('#jform_params_color_button_bg').css('background', $('#jform_params_color_button_bg').val());
    	$('#jform_params_color_button_bg').css('color', getContrastYIQ($('#jform_params_color_button_bg').val())=='black' ? '#000000' : '#FFFFFF');
    	$('#jform_params_color_button_text').css('background', $('#jform_params_color_button_text').val());
    	$('#jform_params_color_button_text').css('color', getContrastYIQ($('#jform_params_color_button_text').val())=='black' ? '#000000' : '#FFFFFF');
    	    	
        var src = regenerateURL();
        
        $('#oeffnungszeiten_preview #oe-searchwidget').css('background', $('#jform_params_color_widget_bg').val());
        $('#oeffnungszeiten_preview #oe-searchwidget').css('color', $('#jform_params_color_text').val());
        $('#oeffnungszeiten_preview #oe-searchwidget-title').css('background', $('#jform_params_color_headline_bg').val());
        $('#oeffnungszeiten_preview #oe-searchwidget-title').css('color', $('#jform_params_color_headline').val());
        
        //Funktion aufrufen um Branding zu aktualisieren
        var widgetwo = $('#jform_params_location').val().replace('#', '');
        var widgetwas = $('#jform_params_search').val().replace('#', '');
        var textcolor = $('#jform_params_color_text').val().replace('#', '');
        getWidgetBranding(widgetwo, widgetwas, textcolor); //In widgetbranding.js
        
        $('#previewWidget').attr('src', src);
    }
    
    function regenerateURL() {
        var widgetwo = $('#jform_params_location').val().replace('#', '');
        var widgetwas = $('#jform_params_search').val().replace('#', '');
        var textcolor = $('#jform_params_color_text').val().replace('#', '');
        var textbgcolor = $('#jform_params_color_widget_bg').val().replace('#', '');
        var buttoncolor = $('#jform_params_color_button_text').val().replace('#', '');
        var buttonbgcolor = $('#jform_params_color_button_bg').val().replace('#', '');
        var url = "http://www.oeffnungszeitenbuch.de/rpc/widget/widget.php?wo="+widgetwo+"&was="+widgetwas+"&textcolor="+textcolor+"&textbgcolor="+textbgcolor+"&buttoncolor="+buttoncolor+"&buttonbgcolor="+buttonbgcolor;
        return url;
    }
});